#!/bin/bash
#
# xipinit-fw.sh, Version 3
#
# (C) Copyright IBM Corp. 2005


#mount point of xipimage
ROMOUNT=""
#name of xipimage
XIPIMAGE=""
#name of device node
RODEV=""

mount -t sysfs none /sys
if [ ! -e /sys/devices/dcssblk ]; then
  echo "xipinit-fw: loading dcssblk module"
  /sbin/modprobe dcssblk
fi
echo $XIPIMAGE > /sys/devices/dcssblk/add

echo "xipinit-fw: mounting read-only segment"
/bin/mount -t ext2 -o ro,xip $RODEV $ROMOUNT
echo "xipinit-fw: binding files"
for i in $(/usr/bin/find $ROMOUNT/*)
do
  if [[ -f $i ]]; then
       /bin/mount --bind $i ${i#$ROMOUNT}
  fi
done
umount /sys

exec /sbin/init $@
